-- Bump.lua - testing the "touch" behaviour
-- arrow should stick to the wall, causing a bump sound
-- sound-test with "1"              -- 24.09.2017 --


local bump = require 'bump'

width = love.graphics.getWidth()
height = love.graphics.getHeight()

bumpsound = love.audio.newSource("thud.ogg", "static")

                                -- Create a Bump-World and
local world = bump.newWorld(50) -- specify the grid cell size! (default = 64)

local arrow = {name="arrow", x = 10, y = 250, w = 120, h = 17, speed = 980}    -- arrow is yellow

local wall = {name="wall", x = width - 30, y = 0 , w = 32, h = height +5, isWall = true}   -- wall is blue

world:add(arrow, arrow.x, arrow.y, arrow.w, arrow.h)     -- insert both rectangles into bump world
world:add(wall, wall.x, wall.y, wall.w, wall.h)          -- x,y, width, height


-- Player functions
local function updatePlayer(dt)
  local speed = arrow.speed
  local dx, dy = 0, 0
  if love.keyboard.isDown('right') then
    dx = speed * dt
  elseif love.keyboard.isDown('left') then
    dx = -speed * dt
  end
  if love.keyboard.isDown('down') then
    dy = speed * dt
  elseif love.keyboard.isDown('up') then
    dy = -speed * dt
  end

  if dx ~= 0 or dy ~= 0 then
    arrow.x, arrow.y, cols, len = world:move(arrow, arrow.x + dx, arrow.y + dy)
      if cols then
        bumpsound:play()
      end
      for i=1,len do
        print('collided with ' .. tostring(cols[i].other))
      end
  end
end

local playerFilter = function(item, other)
  if     other.isCoin   then return 'cross'
  elseif other.isWall   then bumpsound:play()
  elseif other.isSpring then return 'bounce'
  end
  -- else return nil
  
  for i = 1, len do
  --local other = cols[i].other
  
    table.foreach(cols, print)
    for i, v in ipairs(cols[i]) do
      print(i, v)
    end
  end
end

local function drawItem(item, r, g, b)
  love.graphics.setColor(r,g,b,70)
  love.graphics.rectangle("fill", item.x, item.y, item.w, item.h)
  love.graphics.setColor(r,g,b)
  love.graphics.rectangle("line", item.x, item.y, item.w, item.h)
end

function love.update(dt)
  --col_len = 0
  updatePlayer(dt)
end

function love.draw()
  drawItem(arrow, 255, 255, 0)
  drawItem(wall, 0, 0, 255)
end

-- Non-player keypresses
function love.keypressed(k)
  if k=="1" then
    love.audio.stop()
    bumpsound:play()
  elseif k=="escape" then love.event.quit() end
end

